<?php

namespace common\logic\Config\TaxRate;

use common\logic\BaseService;
use common\logic\RepositoryInterface;

class TaxRateRepository extends BaseService implements RepositoryInterface
{
    public function getDefaultOptionsSearch(): array
    {
        return [
            'with' => [],
            'join_with' => [],
            'orderby' => 'pourcent ASC',
            'attribute_id_producer' => ''
        ] ;
    }

    public function findTaxRates(): array
    {
        return TaxRate::find()->all();
    }

    // getTaxRateArray
    public function findTaxRatesAsArray(): array
    {
        $taxRateArrayReturn = [];
        $taxRateArray = $this->findTaxRates();

        foreach($taxRateArray as $taxRate) {
            $taxRateArrayReturn[$taxRate->id] = $taxRate;
        }

        return $taxRateArrayReturn;
    }
}