<?php

namespace common\logic\Distribution\ProductDistribution;

use common\logic\BaseService;
use common\logic\Distribution\Distribution\Distribution;
use common\logic\Order\Order\Order;
use common\logic\Product\Product\Product;
use common\logic\RepositoryInterface;

class ProductDistributionRepository extends BaseService implements RepositoryInterface
{
    public function getDefaultOptionsSearch(): array
    {
        return [
            'with' => ['product','distribution'],
            'join_with' => [],
            'orderby' => '',
            'attribute_id_producer' => ''
        ] ;
    }

    public function findOneProductDistribution(Distribution $distribution, Product $product): ?ProductDistribution
    {
        return ProductDistribution::searchOne([
            'id_distribution' => $distribution->id,
            'id_product' => $product->id
        ]);
    }

    public function findProductDistributionsByDistribution(Distribution $distribution): array
    {
        return ProductDistribution::searchAll([
            'id_distribution' => $distribution->id
        ]) ;
    }

    public function countProductDistributionsByDistribution(Distribution $distribution): int
    {
        return ProductDistribution::searchCount([
            'id_distribution' => $distribution->id
        ]);
    }
}