<?php

namespace common\logic\Order\Order;

use common\logic\ContainerInterface;

class OrderContainer implements ContainerInterface
{
    public function getEntityFqcn(): string
    {
        return Order::class;
    }

    public function getServices(): array
    {
        return [
            OrderSolver::class,
            OrderRepository::class,
            OrderBuilder::class,
            OrderUtils::class
        ];
    }

    public function getSolver(): OrderSolver
    {
        return new OrderSolver();
    }

    public function getRepository(): OrderRepository
    {
        return new OrderRepository();
    }

    public function getBuilder(): OrderBuilder
    {
        return new OrderBuilder();
    }

    public function getUtils(): OrderUtils
    {
        return new OrderUtils();
    }
}