<?php

namespace common\logic\Producer\Producer;

use common\logic\ContainerInterface;

class ProducerContainer implements ContainerInterface
{
    public function getEntityFqcn(): string
    {
        return Producer::class;
    }

    public function getServices(): array
    {
        return [
            ProducerSolver::class,
            ProducerRepository::class,
            ProducerBuilder::class,
            ProducerUtils::class
        ];
    }

    public function getSolver(): ProducerSolver
    {
        return new ProducerSolver();
    }

    public function getRepository()
    {
        return new ProducerRepository();
    }

    public function getBuilder(): ProducerBuilder
    {
        return new ProducerBuilder();
    }

    public function getUtils(): ProducerUtils
    {
        return new ProducerUtils();
    }
}