<?php

namespace common\logic\Subscription\Subscription;

use common\logic\BaseBuilder;
use common\logic\BuilderInterface;
use common\logic\Distribution\Distribution\DistributionRepository;
use common\logic\Subscription\ProductSubscription\ProductSubscription;

class SubscriptionBuilder extends BaseBuilder implements BuilderInterface
{
    protected DistributionRepository $distributionRepository;

    public function __construct()
    {
        $this->distributionRepository = $this->loadService(DistributionRepository::class);
    }

    public function instanciateSubscription(): Subscription
    {
        $subscription = new Subscription();

        return $subscription;
    }

    public function createSubscription(): Subscription
    {
        $subscription = $this->instanciateSubscription();
        $this->saveCreate($subscription);

        return $subscription;
    }

    public function deleteSubscription(Subscription $subscription): void
    {
        ProductSubscription::deleteAll(['id_subscription' => $subscription->id]);
        $this->delete($subscription);
    }
}