<?php

namespace common\logic\User\User;

use common\logic\ContainerInterface;

class UserContainer implements ContainerInterface
{
    public function getEntityFqcn(): string
    {
        return User::class;
    }

    public function getServices(): array
    {
        return [
            UserSolver::class,
            UserRepository::class,
            UserBuilder::class,
            UserUtils::class,
        ];
    }

    public function getSolver(): UserSolver
    {
        return new UserSolver();
    }

    public function getRepository(): UserRepository
    {
        return new UserRepository();
    }

    public function getBuilder(): UserBuilder
    {
        return new UserBuilder();
    }

    public function getUtils(): UserUtils
    {
        return new UserUtils();
    }
}